<?php
	class MdlSessionHandler extends Mdl implements SessionHandlerInterface, SessionUpdateTimestampHandlerInterface {
		const SECONDS = 1200;// 20 mins
		
		function open($path, $name) {
			return true;
		}
		function read($id) {
			$sth = $this->pdo()->prepare('SELECT data FROM session WHERE id = :id');
			$sth->execute(array('id' => $id));
			return (string)@$sth->fetch()['data'];
		}
		function write($id, $data) {
			$sth = $this->pdo()->prepare('INSERT INTO session (id, date, data, uid) VALUES (:id, NOW(), :data, :uid) ON DUPLICATE KEY UPDATE date = NOW(), data = :data, uid = :uid');
			return $sth->execute(array('id' => $id, 'data' => $data, 'uid' => USERID));
		}
		function close() {
			return true;
		}
		function destroy($id) {
			return $this->pdo()->prepare('DELETE FROM session WHERE id = :id')->execute(array('id' => $id));
		}
		function gc($max_lifetime) {
			$this->pdo()->prepare('DELETE FROM session WHERE date <= DATE_SUB(NOW(), INTERVAL ' . self::SECONDS . ' second)')->execute();
			return true;
		}
		
		function updateTimestamp($id, $data) {
			return $this->pdo()->prepare('UPDATE session SET date = NOW(), uid = :uid WHERE id = :id')->execute(array('id' => $id, 'uid' => USERID));
		}
		function validateId($id) {
			$sth = $this->pdo()->prepare('SELECT 1 FROM session WHERE id = :id AND date > DATE_SUB(NOW(), INTERVAL ' . self::SECONDS . ' second)');
			$sth->execute(array('id' => $id));
			return $sth->rowCount() > 0;
		}
	}
?>
