<?php
	class VueStr extends Vue {
		const PATH = __DIR__ . '/../util/STR.json';
		
		protected function authorize($post) {
			return USER === 'admin';
		}
		
		protected function handlePOST() {
			$array = json_decode(file_get_contents(self::PATH), true);
			
			@list($key, $value) = (array)$_POST['new'];
			if (isset($_POST['add'])) {
				$array[LANG][$key] = $value;
			}
			if (isset($_POST['del'])) {
				unset($array[LANG][$key]);
			}
			
			ksort($array);
			ksort($array[LANG]);
			file_put_contents(self::PATH, json_encode($array, JSON_PRETTY_PRINT));
			
			HTTP::Reload();
		}
		
		protected function render() {
			$array = json_decode(file_get_contents(self::PATH), true);
			
			$this->renderTitle(STR::text('Strings') . ' (' . LANG . ')');
?>
<table border=1 cellpadding=10 width=100%>
<?php foreach ((array)@$array[LANG] as $key => $value): ?>
<?php
	$url = '?' . http_build_query(array('key' => array($key, $value)));
?>
	<tr>
		<th align=left nowrap width=1><?= htmlspecialchars($key) ?></th>
		<td><?= htmlspecialchars($value) ?></td>
		<td nowrap width=1><a href="<?= htmlspecialchars($url) ?>"><?= STR::html('Edit') ?></a></th>
	</tr>
<?php endforeach; ?>
</table>
<?php if (is_writable(self::PATH)): ?>
<form action="<?= URL::FullURLHTML(PAGE) ?>" method=post><table border=1 cellpadding=10>
	<tr>
		<th align=right width=1><?= STR::html('Key') ?></th>
		<td><input name=new[0] value="<?= htmlspecialchars(@$_GET['key'][0]) ?>" /></td>
	</tr>
	<tr>
		<th align=right width=1><?= STR::html('Value') ?></th>
		<td><input name=new[1] value="<?= htmlspecialchars(@$_GET['key'][1]) ?>" /></td>
	</tr>
	<tr><td colspan=2>
		<button name=add><?= STR::html('Add / Edit') ?></button>
		<button name=del><?= STR::html('Delete') ?></button>
	</td>
</table></form>
<?php else: ?>
<p class=error><?= STR::html('app/util/STR.json is not writable') ?></p>
<?php endif; ?>
<?php
		}
	}
?>
